//Software exemplo para leitura de temperatura
//Utilizando o shield OPS012 e termopar (K ou J)
//Nesse software utilizaremos apenas a entrada AT1

//Biblioteca para temperatura
//É preciso instalar a biblioteca em "Gerenciar Bibliotecas..."
#include <HX711_ADC.h>

//Pinos para entradas de temperatura
const int pin_DOUT1 = 18;
const int pin_SCK1 = 5;

//chamada da biblioteca de leitura do conversor ADC
HX711_ADC Sensor1(pin_DOUT1, pin_SCK1);

//Variáveis de controle
long TMP_Raw = 0;                     //Valor da saída crua do conversor ADC
long TMP_Calibrado = 0;               //Valor de temperatura calibrado
long TMP_Ponto_1_Analog = 8765432;    //Valor analógico para calibração referente a 10.0°C
long TMP_Ponto_1_Temp = 100;          //Valor temperatura para calibração referente a 10.0°C (verificar que existe a casa decimal, mas sem ponto por se tratar de um valor inteiro)
long TMP_Ponto_2_Analog = 9345678;    //Valor analógico para calibração referente a 50.0°C
long TMP_Ponto_2_Temp = 500;          //Valor temperatura para calibração referente a 50.0°C (verificar que existe a casa decimal, mas sem ponto por se tratar de um valor inteiro)

void setup() {
  //Inicializa comunicações
  Serial.begin(115200); // (USB)
  
  //Inicialização da biblioteca HX711
  Sensor1.begin();
  Sensor1.start(2000, false);
  Sensor1.setCalFactor(1);
  
}

void loop() {

  //************************************************************************************
  //Leitura da entrada do conversor ADC
  //O valor de entrada tem 24 bits de resolução
  //************************************************************************************
  if (Sensor1.update()) {
    TMP_Raw = Sensor1.getData();
  }
  //Calibração da curva do sensor
  //Nesse caso estamos calibrando para 10.0°C e 50.0°C
  //Os valores são arbitrários, apenas com o propósito demonstrativo
  TMP_Calibrado = map(TMP_Raw, TMP_Ponto_1_Analog, TMP_Ponto_2_Analog, TMP_Ponto_1_Temp, TMP_Ponto_2_Temp);

}
